#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, INF = 1e18, MOD = 1e9;

struct point {
    int x, y;

    point(long long x, long long y) : x(x), y(y) {}

    point() {}

    int len() {
        return x * x + y * y;
    }

    point operator+ (point b) {
        return point(x + b.x, y + b.y);
    }

    point operator- (point b) {
        return point(x - b.x, y - b.y);
    }

    int operator* (point b) {
        return x * b.y - b.x * y;
    }

    int operator% (point b) {
        return x * y - b.x * b.y;
    }
};

int t, n;
point p[N][5], l[N][5];
vector<vector<int>> ge;
vector<int> cur;

void gen() {
    if (cur.size() == 3) {
        ge.push_back(cur);
        return;
    }
    cur.push_back(1);
    gen();
    cur.pop_back();
    cur.push_back(2);
    gen();
    cur.pop_back();
    cur.push_back(3);
    gen();
    cur.pop_back();
}

bool gg(vector<int> a) {
    point pp1, pp2, pp3;
    for (vector<int> &c : ge) {
        if (l[a[0]][0].len() != l[a[1]][c[0]].len() || l[a[0]][1].len() != l[a[1]][c[1]].len() || l[a[0]][2].len() != l[a[2]][c[2]].len()) continue;
        pp1 = p[a[0]][0]
    }
}

bool good(int a1, int a2, int a3, int a4) {
    return true;
    vector<int> a = {a1, a2, a3, a4};
    do {
        if (gg(a)) {
            return true;
        }
    } while (next_permutation(a.begin(), a.end()));
    return false;
}

void solve() {
    gen();
    cin >> t >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i][1].x >> p[i][1].y >> p[i][2].x >> p[i][2].y >> p[i][3].x >> p[i][3].y;
        p[i][0] = p[i][2];
        p[i][4] = p[i][1];
        l[i][1] = p[i][2] - p[i][1];
        l[i][2] = p[i][3] - p[i][2];
        l[i][3] = p[i][1] - p[i][3];
        l[i][0] = l[i][3];
        l[i][4] = l[i][1];
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    for (int f = 0; f < n; f++) {
        for (int s = f + 1; s < n; s++) {
            for (int e = s + 1; e < n; e++) {
                for (int u = e + 1; u < n; u++) {
                    if (good(f, s, e, u)) {
                        ans.push_back({{f, s}, {e, u}});
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " << ans[i].second.first + 1 << " " << ans[i].second.second + 1 << '\n';
    }
}
