#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 1, K = 100, INF = 1e18, BASE = 191, MOD = 1e9 + 7;

int n, m, hs[N], hhs[N], p[N];
vector<int> a, b;

bool good(int l) {
    set<int> se;
    for (int i = 0; i < m - l + 1; i++) {
        int hh = 0;
        for (int j = 0; j < l; j++) {
            int val = b[j] - min(b[j], b[i + l - j - 1]);
            hh = (hh * BASE + val) % MOD;
        }
        se.insert(hh);
    }
//    for (int i = 1; i <= m; i++) {
//        hs[i] = (hs[i - 1] * BASE + b[i - 1]) % MOD;
//        if (i >= l) {
//            se.insert((hs[i] - (hs[i - l] * p[l] % MOD) + MOD) % MOD);
//        }
//    }
    for (int i = 0; i < n - l + 1; i++) {
        int hh = 0;
        for (int j = 0; j < l; j++) {
            int val = a[j] - min(a[j], a[i + l - j - 1]);
            hh = (hh * BASE + val) % MOD;
        }
        if (se.count(hh)) {
            return true;
        }
    }
//    for (int pl = -K; pl <= K; pl++) {
//        for (int i = 1; i <= n; i++) {
//            hs[i] = (hs[i - 1] * BASE + a[i - 1] + pl) % MOD;
//            if (i >= l) {
//                if (se.count((hs[i] - (hs[i - l] * p[l] % MOD) + MOD) % MOD)) {
//                    return true;
//                }
//            }
//        }
//    }
    return false;
}

void solve() {
    p[0] = 1;
    for (int i = 1; i < N; i++) {
        p[i] = p[i - 1] * BASE % MOD;
    }
    cin >> n >> m;
    a.resize(n);
    b.resize(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    reverse(b.begin(), b.end());
    int l = 0, r = min(n, m) + 1;
    while (l + 1 < r) {
        int md = (r + l) / 2;
        if (good(md)) l = md;
        else r = md;
    }
    cout << l;
}