#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, K = 100, INF = 1e18, BASE = 1337, MOD = 1e9 + 7, BASE1 = 228, MOD1 = 1e9 + 9;

int n, m, ans, hs[N], rhs[N], p[N], hs1[N], rhs1[N], p1[N];
vector<int> a, b;

bool good1(int l) {
    if (l == 1) return true;
    set<pair<int, int>> se;
    hs[0] = b[0];
    for (int i = 1; i < m; i++) {
        hs[i] = (hs[i - 1] * BASE + b[i]) % MOD;
    }
    hs1[0] = b[0];
    for (int i = 1; i < m; i++) {
        hs1[i] = (hs1[i - 1] * BASE1 + b[i]) % MOD1;
    }
    rhs[m] = 0;
    for (int i = m - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * BASE + b[i]) % MOD;
    }
    rhs1[m] = 0;
    for (int i = m - 1; i >= 0; i--) {
        rhs1[i] = (rhs1[i + 1] * BASE1 + b[i]) % MOD1;
    }
    for (int i = 0; i < m - l + 1; i++) {
        int m1 = i + l / 2;
        int q = (rhs[i] - (rhs[m1 + 1] * p[l / 2 + 1] % MOD) + MOD) % MOD;
        int w = (hs[i + l - 1] - (hs[m1 - 1] * p[l / 2 + 1] % MOD) + MOD) % MOD;
        int qq = (rhs1[i] - (rhs1[m1 + 1] * p1[l / 2 + 1] % MOD1) + MOD1) % MOD1;
        int ww = (hs1[i + l - 1] - (hs1[m1 - 1] * p1[l / 2 + 1] % MOD1) + MOD1) % MOD1;
        se.insert({(q - w + MOD) % MOD, (qq - ww + MOD1) % MOD1});
    }
    hs[0] = a[0];
    for (int i = 1; i < n; i++) {
        hs[i] = (hs[i - 1] * BASE + a[i]) % MOD;
    }
    hs1[0] = a[0];
    for (int i = 1; i < n; i++) {
        hs1[i] = (hs1[i - 1] * BASE1 + a[i]) % MOD1;
    }
    rhs[n] = 0;
    for (int i = n - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * BASE + a[i]) % MOD;
    }
    rhs1[n] = 0;
    for (int i = n - 1; i >= 0; i--) {
        rhs1[i] = (rhs1[i + 1] * BASE + a[i]) % MOD1;
    }
    for (int i = 0; i < n - l + 1; i++) {
        int m1 = i + l / 2;
        int q = (rhs[i] - (rhs[m1 + 1] * p[l / 2 + 1] % MOD) + MOD) % MOD;
        int w = (hs[i + l - 1] - (hs[m1 - 1] * p[l / 2 + 1] % MOD) + MOD) % MOD;
        int qq = (rhs1[i] - (rhs1[m1 + 1] * p1[l / 2 + 1] % MOD1) + MOD1) % MOD1;
        int ww = (hs1[i + l - 1] - (hs1[m1 - 1] * p1[l / 2 + 1] % MOD1) + MOD1) % MOD1;
        if (se.count({(q - w + MOD) % MOD, (qq - ww + MOD1) % MOD1})) {
            return true;
        }
    }
    return false;
}
bool good2(int l) {
    set<pair<int, int>> se;
    hs[0] = b[0];
    for (int i = 1; i < m; i++) {
        hs[i] = (hs[i - 1] * BASE + b[i]) % MOD;
    }
    hs1[0] = b[0];
    for (int i = 1; i < m; i++) {
        hs1[i] = (hs1[i - 1] * BASE1 + b[i]) % MOD1;
    }
    rhs[m] = 0;
    for (int i = m - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * BASE + b[i]) % MOD;
    }
    rhs1[m] = 0;
    for (int i = m - 1; i >= 0; i--) {
        rhs1[i] = (rhs1[i + 1] * BASE1 + b[i]) % MOD1;
    }
    for (int i = 0; i < m - l + 1; i++) {
        int m1 = i + l / 2 - 1;
        int m2 = i + l / 2;
        int q = (rhs[i] - (rhs[m2] * p[l / 2] % MOD) + MOD) % MOD;
        int w = (hs[i + l - 1] - (hs[m1] * p[l / 2] % MOD) + MOD) % MOD;
        int qq = (rhs1[i] - (rhs1[m2] * p1[l / 2] % MOD1) + MOD1) % MOD1;
        int ww = (hs1[i + l - 1] - (hs1[m1] * p1[l / 2] % MOD1) + MOD1) % MOD1;
        se.insert({(q - w + MOD) % MOD, (qq - ww + MOD1) % MOD1});
    }
    hs[0] = a[0];
    for (int i = 1; i < n; i++) {
        hs[i] = (hs[i - 1] * BASE + a[i]) % MOD;
    }
    hs1[0] = a[0];
    for (int i = 1; i < n; i++) {
        hs1[i] = (hs1[i - 1] * BASE1 + a[i]) % MOD1;
    }
    rhs[n] = 0;
    for (int i = n - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * BASE + a[i]) % MOD;
    }
    rhs1[n] = 0;
    for (int i = n - 1; i >= 0; i--) {
        rhs1[i] = (rhs1[i + 1] * BASE + a[i]) % MOD1;
    }
    for (int i = 0; i < n - l + 1; i++) {
        int m1 = i + l / 2 - 1;
        int m2 = i + l / 2;
        int q = (rhs[i] - (rhs[m2] * p[l / 2] % MOD) + MOD) % MOD;
        int w = (hs[i + l - 1] - (hs[m1] * p[l / 2] % MOD) + MOD) % MOD;
        int qq = (rhs1[i] - (rhs1[m2] * p1[l / 2] % MOD1) + MOD1) % MOD1;
        int ww = (hs1[i + l - 1] - (hs1[m1] * p1[l / 2] % MOD1) + MOD1) % MOD1;
        if (se.count({(q - w + MOD) % MOD, (qq - ww + MOD1) % MOD1})) {
            return true;
        }
    }
    return false;
}

void solve() {
    p[0] = 1;
    for (int i = 1; i < N; i++) {
        p[i] = p[i - 1] * BASE % MOD;
    }
    p1[0] = 1;
    for (int i = 1; i < N; i++) {
        p1[i] = p1[i - 1] * BASE1 % MOD1;
    }
    cin >> n >> m;
    a.resize(n);
    b.resize(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    reverse(b.begin(), b.end());
    int l = 0, r = N;
    while (l + 1 < r) {
        int md = (r + l) / 2;
        int ll = (md * 2 + 1);
        if (ll > min(n, m)) r = md;
        else if (good1(ll)) {
            l = md;
        } else {
            r = md;
        }
    }
    ans = l * 2 + 1;
    l = 0, r = N;
    while (l + 1 < r) {
        int md = (r + l) / 2;
        int ll = md * 2;
        if (ll > min(n, m)) r = md;
        else if (good2(ll)) {
            l = md;
        } else {
            r = md;
        }
    }
    ans = max(ans, l * 2);
    cout << ans;
}