#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, INF = 1e18, MOD = 1e9;

int man(vector<int> a) {
    vector<int> pa;
    pa.reserve(2 * (int) a.size());
    for (int el : a) {
        pa.push_back(0);
        pa.push_back(el);
    }
    pa.push_back(0);
    a = pa;
    int res = 0, k, l = 0, r = -1, n = a.size();
    vector<int> m(n);
    for (int i = 0; i < n; i++) {
        if (r <= i) {
            k = 1;
        } else {
            k = min(r - i, m[r + l - i]);
        }
        while (i - k >= 0 && i + k < n && a[i - k] == a[i + k]) {
            k++;
        }
        m[i] = k;
        res = max(res, m[i] - 1);
    }
    return res;
}

int n, m, ans;
vector<int> a, b;

void solve() {
    cin >> n >> m;
    a.resize(n);
    b.resize(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int val = -1;
    bool ok = true;
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        if (val == -1) {
            val = b[i];
        } else if (val != b[i]) {
            ok = false;
        }
    }
    if (ok) {
        cout << man(a);
        return;
    }
    for (int i = 0; i < m; i++) {
        int e = min(n, m - i);
        vector<int> c(e);
        for (int j = 0; j < e; j++) {
            c[j] = a[j] + b[i + j];
        }
        ans = max(ans, man(c));
    }
    cout << ans;
}
