#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, K = 101;

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}


int n, q;
vector<int> a, b, c;
vector<pair<int, int>> e;

bool cmp(pair<int, int> f, pair<int, int> s) {
    if (f.first < s.first && f.second < s.second) return false;
    return a[f.first] * b[s.second] < a[s.first] * b[f.second];
}

void solve() {
    cin >> n >> q;
    a.resize(n);
    b.resize(n);
    c.resize(q);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());
    for (int i = 0; i < min(n, K); i++) {
        for (int j = 0; j < n; j++) {
            e.push_back({i, j});
        }
    }
    sort(e.begin(), e.end(), cmp);
    for (int i = 0; i < q; i++) {
        cin >> c[i];
        c[i]--;
    }
    for (int i = 0; i < q; i++) {
        int gc = gcd(a[e[c[i]].first], b[e[c[i]].second]);
        cout << a[e[c[i]].first] / gc << " " << b[e[c[i]].second] / gc << '\n';
    }
}
