#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, A = 1e6 + 100, K = 1e3;

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}


int n, q, cnt[A];
vector<int> a, b, c;

bool cmp(pair<int, int> f, pair<int, int> s) {
    if (f.first < s.first && f.second < s.second) return true;
    return a[f.first] * b[s.second] < a[s.first] * b[f.second];
}

bool more(pair<int, int> f, pair<int, int> s) {
    if (a[f.first] * b[s.second] == a[s.first] * b[f.second]) {
        return f.first > s.first;
    }
    return a[f.first] * b[s.second] > a[s.first] * b[f.second];
}

int pos(int f, int s) {
//    int res = 0;
//    for (int i = 0; i < n; i++) {
//        int l = -1, r = n;
//        while (l + 1 < r) {
//            int m = (r + l) / 2;
//            if (!more({i, m}, {f, s})) {
//                l = m;
//            } else {
//                r = m;
//            }
//        }
//        res += l + 1;
//    }
//    return res;
    int res = 0;
    for (int j = 0; j < n; j++) {
        int e = (a[f] * b[j] + b[s] - 1) / b[s];
        for (int i = 0; i < n; i++) {
            if (!more({i, j}, {f, s})) {
                res++;
            }
//            if (a[i] <= e) {
//                res++;
//            }
        }
//        res += cnt[e];
    }
    return res;
}

void solve() {
    cin >> n >> q;
    a.resize(n);
    b.resize(n);
    c.resize(q);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i]]++;
    }
    for (int i = 1; i < A; i++) {
        cnt[i] += cnt[i - 1];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());
    for (int i = 0; i < q; i++) {
        cin >> c[i];
    }
    int l, r, m;
    for (int qq = 0; qq < q; qq++) {
        int e = c[qq], mn = 100, ii = -1, ll = -1;
        for (int i = 0; i < n; i++) {
            l = 0, r = n;
            while (l + 1 < r) {
                m = (r + l) / 2;
                if (pos(i, m) <= e) {
                    l = m;
                } else {
                    r = m;
                }
            }
            int o = pos(i, l);
            if (o >= e && mn > o - e) {
                mn = o - e;
                ii = i;
                ll = l;
            }
        }
        int gc = gcd(a[ii], b[ll]);
        cout << a[ii] / gc << " " << b[ll] / gc << '\n';
    }
}