#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, K = 3e3 + 100;

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

bool cmp(pair<int, int> f, pair<int, int> s) {
    return f.first * s.second < s.first * f.second;
}

int n, q;
vector<int> a, b, c;
vector<pair<int, int>> e;

void solve() {
    cin >> n >> q;
    a.resize(n);
    b.resize(n);
    c.resize(q);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    for (int i = 0; i < min(n, K); i++) {
        for (int j = 0; j < min(n, K); j++) {
            int gc = gcd(a[i], b[j]);
            e.push_back({a[i] / gc, b[j] / gc});
        }
    }
    sort(e.begin(), e.end(), cmp);

    for (int i = 0; i < q; i++) {
        cin >> c[i];
        c[i]--;
    }
    for (int i = 0; i < q; i++) {
        cout << e[c[i]].first << " " << e[c[i]].second << '\n';
    }
}
