#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100;

int n, k, w[N];
int dp[N][2];
vector<int> a[N];

bool cmp(int f, int s) {
    return dp[f][1] - dp[f][0] < dp[s][1] - dp[s][0];
}

void dfs(int v) {
    for (int to : a[v]) {
        dfs(to);
    }
    sort(a[v].begin(), a[v].end(), cmp);
    for (int i = 0; i < a[v].size(); i++) {
        int to = a[v][i];
        if (i + 1 <= k) {
            dp[v][1] += dp[to][0] + 1;
        } else {
            dp[v][1] += dp[to][1];
        }
        if (i + 1 < k) {
            dp[v][0] += dp[to][0] + 1;
        } else {
            dp[v][0] += dp[to][1];
        }
    }
//    for (int i = 0; i < a[v].size(); i++) {
//        int to = a[v][i];
//        if (i + 1 <= k) {
//            dp[v][0] = {dp[v][0].first + 1, dp[v][0].second + w[to]};
//            dp[v][1] = {dp[v][1].first + 1, dp[v][1].second + w[to]};
//        } else if (i + 1 == k) {
//            dp[v][1] = {dp[v][1].first + 1, dp[v][1].second + w[to]};
//        } else {
//            break;
//        }
//    }
}

void solve() {
    cin >> n >> k;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p >> w[i];
        p--;
        a[p].push_back(i);
    }
    dfs(0);
    cout << dp[0][1] << " " << 0;
}
