#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, K = 1e3;

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}


int n, q;
vector<int> a, b, c;

bool cmp(pair<int, int> f, pair<int, int> s) {
    if (f.first < s.first && f.second < s.second) return true;
    return a[f.first] * b[s.second] < a[s.first] * b[f.second];
}

bool more(pair<int, int> f, pair<int, int> s) {
    return a[f.first] * b[s.second] > a[s.first] * b[f.second];
}

void solve() {
    cin >> n >> q;
    a.resize(n);
    b.resize(n);
    c.resize(q);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());
    for (int i = 0; i < q; i++) {
        cin >> c[i];
    }
    int l, r, m;
    for (int qq = 0; qq < q; qq++) {
        int e = c[qq];
        bool ok = false;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (e < (i + 1) * (j + 1)) break;
                int w = 0;
//                if (i < j) {
                    for (int h = 0; h < n; h++) {
                        l = -1, r = n;
                        while (l + 1 < r) {
                            m = (r + l) / 2;
                            if (more({h, m}, {i, j})) {
                                r = m;
                            } else {
                                l = m;
                            }
                        }
                        w += l + 1;
                    }
//                } else {
//
//                }
                if (w == e) {
                    int gc = gcd(a[i], b[j]);
                    cout << a[i] / gc << " " << b[j] / gc << '\n';
                    ok = true;
                    break;
                }
            }
            if (ok) {
                break;
            }
        }
    }
}