#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100;

int n, k, w[N];
pair<int, int> dp[N][2];
deque<int> a[N];

bool cmp(int f, int s) {
    if (dp[f][1].first - dp[f][0].first == dp[s][1].first - dp[s][0].first) {
        return (dp[f][0].second + w[f]) - dp[f][1].second > (dp[s][0].second + w[s]) - dp[s][1].second;
    }
    return dp[f][1].first - dp[f][0].first < dp[s][1].first - dp[s][0].first;
}

bool cmp1(int f, int s) {
    return (dp[f][0].second + w[f]) - dp[f][1].second > (dp[s][0].second + w[s]) - dp[s][1].second;
}

void dfs(int v) {
    for (int to : a[v]) {
        dfs(to);
    }
    deque<int> d = a[v];
    sort(d.begin(), d.end(), cmp);
    int cnt0 = 0, cnt1 = 0;
    for (int i = 0; i < d.size(); i++) {
        int to = d[i];
        if (cnt1 + 1 <= k && dp[to][0].first + 1 > dp[to][1].first) {
            dp[v][1].first += dp[to][0].first + 1;
            dp[v][1].second += dp[to][0].second + w[to];
            cnt1++;
        } else {
            break;
        }
    }

    for (int i = 0; i < cnt1; i++) {
        d.pop_front();
    }
    sort(d.begin(), d.end(), cmp1);
    for (int i = 0; i < d.size(); i++) {
        int to = d[i];
        if (cnt1 + 1 <= k && dp[to][0].second + w[to] < dp[to][1].second) {
            dp[v][1].first += dp[to][0].first + 1;
            dp[v][1].second += dp[to][0].second + w[to];
            cnt1++;
        } else {
            dp[v][1].first += dp[to][1].first;
            dp[v][1].second += dp[to][1].second;
        }
    }

    d = a[v];
    sort(d.begin(), d.end(), cmp);
    for (int i = 0; i < d.size(); i++) {
        int to = d[i];
        if (cnt0 + 1 < k && dp[to][0].first + 1 > dp[to][1].first) {
            dp[v][0].first += dp[to][0].first + 1;
            dp[v][0].second += dp[to][0].second + w[to];
            cnt0++;
        } else {
            break;
        }
    }
    for (int i = 0; i < cnt0; i++) {
        d.pop_front();
    }
    sort(d.begin(), d.end(), cmp1);
    for (int i = 0; i < d.size(); i++) {
        int to = d[i];
        if (cnt0 + 1 < k && dp[to][0].second + w[to] < dp[to][1].second) {
            dp[v][0].first += dp[to][0].first + 1;
            dp[v][0].second += dp[to][0].second + w[to];
            cnt0++;
        } else {
            dp[v][0].first += dp[to][1].first;
            dp[v][0].second += dp[to][1].second;
        }
    }
}

void solve() {
    cin >> n >> k;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p >> w[i];
        p--;
        a[p].push_back(i);
    }
    dfs(0);
    cout << dp[0][1].first << " ";
    if (dp[0][1].first == dp[0][0].first) {
        cout << min(dp[0][1].second, dp[0][0].second);
    } else {
        cpit << dp[0][1].second;
    }
}